using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Ex08_1;

namespace Ex08_3
{
    public class CQueue
    {
        private Clist m_List;    //创建链表对象实例

        public CQueue()      //构造函数
        {
              m_List = new Clist();

        }
                                            // 入队
        public void EnQueue(int DataValue)
        {
            //功能：加入队列，这里使用List 类的Append 方法：

            //尾部添加数据，数据个数加1

            m_List.Append(DataValue);
        }


                                       // 出队

        public int DeQueue()
        {
            //功  能：出队

            //返回值： 2147483647 表示为空队列无返回

            int QueValue;

            if (!IsNull())
            {
                //不为空的队列

                //移动到队列的头

                m_List.MoveFrist();

                //取得当前的值

                QueValue = m_List.GetCurrentValue();

                //删除出队的数据

                m_List.Delete();

                return QueValue;

            }
            return 2147483647;
        }


                                     // 判断队列是否为空

        public bool IsNull()
        {
            //功能：判断是否为空的队列

            return m_List.IsNull();

        }


                                 // 清空队列

        public void Clear()
        {
            m_List.Clear();       //清空链表
        }

                               // 取得队列的数据个数

        public int QueueCount
        {
            get
            {
                return m_List.ListCount;    //取得队列的个数
            }
        }
    }
}
